diff --git a/external/fmt/test/format-test.cc b/external/fmt/test/format-test.cc
index 2a25566c..a8592ef0 100644
--- a/external/fmt/test/format-test.cc
+++ b/external/fmt/test/format-test.cc
@@ -356,589 +321,576 @@ TEST(MemoryBufferTest, ExceptionInDeallocate) {
   EXPECT_CALL(alloc, deallocate(&mem2[0], 2 * size));
 }
 
-TEST(UtilTest, UTF8ToUTF16) {
-  fmt::detail::utf8_to_utf16 u("лошадка");
-  EXPECT_EQ(L"\x043B\x043E\x0448\x0430\x0434\x043A\x0430", u.str());
-  EXPECT_EQ(7, u.size());
-  // U+10437 { DESERET SMALL LETTER YEE }
-  EXPECT_EQ(L"\xD801\xDC37", fmt::detail::utf8_to_utf16("𐐷").str());
-  EXPECT_THROW_MSG(fmt::detail::utf8_to_utf16("\xc3\x28"), std::runtime_error,
-                   "invalid utf8");
-  EXPECT_THROW_MSG(fmt::detail::utf8_to_utf16(fmt::string_view("л", 1)),
-                   std::runtime_error, "invalid utf8");
-  EXPECT_EQ(L"123456", fmt::detail::utf8_to_utf16("123456").str());
-}
-
-TEST(UtilTest, UTF8ToUTF16EmptyString) {
-  std::string s = "";
-  fmt::detail::utf8_to_utf16 u(s.c_str());
-  EXPECT_EQ(L"", u.str());
-  EXPECT_EQ(s.size(), u.size());
-}
-
-TEST(UtilTest, FormatSystemError) {
-  fmt::memory_buffer message;
-  fmt::format_system_error(message, EDOM, "test");
-  EXPECT_EQ(fmt::format("test: {}", get_system_error(EDOM)),
-            to_string(message));
-  message = fmt::memory_buffer();
-
-  // Check if std::allocator throws on allocating max size_t / 2 chars.
-  size_t max_size = max_value<size_t>() / 2;
-  bool throws_on_alloc = false;
-  try {
-    std::allocator<char> alloc;
-    alloc.deallocate(alloc.allocate(max_size), max_size);
-  } catch (const std::bad_alloc&) {
-    throws_on_alloc = true;
-  }
-  if (!throws_on_alloc) {
-    fmt::print("warning: std::allocator allocates {} chars", max_size);
-    return;
+template <typename Allocator, size_t MaxSize>
+class max_size_allocator : public Allocator {
+ public:
+  using typename Allocator::value_type;
+  size_t max_size() const FMT_NOEXCEPT { return MaxSize; }
+  value_type* allocate(size_t n) {
+    if (n > max_size()) {
+      throw std::length_error("size > max_size");
+    }
+    return std::allocator_traits<Allocator>::allocate(
+        *static_cast<Allocator*>(this), n);
   }
-  fmt::format_system_error(message, EDOM, fmt::string_view(nullptr, max_size));
-  EXPECT_EQ(fmt::format("error {}", EDOM), to_string(message));
-}
-
-TEST(UtilTest, SystemError) {
-  fmt::system_error e(EDOM, "test");
-  EXPECT_EQ(fmt::format("test: {}", get_system_error(EDOM)), e.what());
-  EXPECT_EQ(EDOM, e.error_code());
-
-  fmt::system_error error(0, "");
-  try {
-    throw fmt::system_error(EDOM, "test {}", "error");
-  } catch (const fmt::system_error& e) {
-    error = e;
+  void deallocate(value_type* p, size_t n) {
+    std::allocator_traits<Allocator>::deallocate(*static_cast<Allocator*>(this),
+                                                 p, n);
   }
-  fmt::memory_buffer message;
-  fmt::format_system_error(message, EDOM, "test error");
-  EXPECT_EQ(to_string(message), error.what());
-  EXPECT_EQ(EDOM, error.error_code());
-}
-
-TEST(UtilTest, ReportSystemError) {
-  fmt::memory_buffer out;
-  fmt::format_system_error(out, EDOM, "test error");
-  out.push_back('\n');
-  EXPECT_WRITE(stderr, fmt::report_system_error(EDOM, "test error"),
-               to_string(out));
-}
-
-TEST(StringViewTest, Ctor) {
-  EXPECT_STREQ("abc", string_view("abc").data());
-  EXPECT_EQ(3u, string_view("abc").size());
-
-  EXPECT_STREQ("defg", string_view(std::string("defg")).data());
-  EXPECT_EQ(4u, string_view(std::string("defg")).size());
-}
-
-TEST(FormatToTest, FormatWithoutArgs) {
-  std::string s;
-  fmt::format_to(std::back_inserter(s), "test");
-  EXPECT_EQ("test", s);
-}
-
-TEST(FormatToTest, Format) {
-  std::string s;
-  fmt::format_to(std::back_inserter(s), "part{0}", 1);
-  EXPECT_EQ("part1", s);
-  fmt::format_to(std::back_inserter(s), "part{0}", 2);
-  EXPECT_EQ("part1part2", s);
-}
+};
 
-TEST(FormatToTest, WideString) {
-  std::vector<wchar_t> buf;
-  fmt::format_to(std::back_inserter(buf), L"{}{}", 42, L'\0');
-  EXPECT_STREQ(buf.data(), L"42");
+TEST(memory_buffer_test, max_size_allocator) {
+  // 160 = 128 + 32
+  using test_allocator = max_size_allocator<std::allocator<char>, 160>;
+  basic_memory_buffer<char, 10, test_allocator> buffer;
+  buffer.resize(128);
+  // new_capacity = 128 + 128/2 = 192 > 160
+  buffer.resize(160);  // Shouldn't throw.
 }
 
-TEST(FormatToTest, FormatToMemoryBuffer) {
-  fmt::basic_memory_buffer<char, 100> buffer;
-  fmt::format_to(buffer, "{}", "foo");
-  EXPECT_EQ("foo", to_string(buffer));
-  fmt::wmemory_buffer wbuffer;
-  fmt::format_to(wbuffer, L"{}", L"foo");
-  EXPECT_EQ(L"foo", to_string(wbuffer));
+TEST(memory_buffer_test, max_size_allocator_overflow) {
+  using test_allocator = max_size_allocator<std::allocator<char>, 160>;
+  basic_memory_buffer<char, 10, test_allocator> buffer;
+  EXPECT_THROW(buffer.resize(161), std::exception);
 }
 
-TEST(FormatterTest, Escape) {
-  EXPECT_EQ("{", format("{{"));
-  EXPECT_EQ("before {", format("before {{"));
-  EXPECT_EQ("{ after", format("{{ after"));
-  EXPECT_EQ("before { after", format("before {{ after"));
+TEST(format_test, escape) {
+  EXPECT_EQ("{", fmt::format("{{"));
+  EXPECT_EQ("before {", fmt::format("before {{"));
+  EXPECT_EQ("{ after", fmt::format("{{ after"));
+  EXPECT_EQ("before { after", fmt::format("before {{ after"));
 
-  EXPECT_EQ("}", format("}}"));
-  EXPECT_EQ("before }", format("before }}"));
-  EXPECT_EQ("} after", format("}} after"));
-  EXPECT_EQ("before } after", format("before }} after"));
+  EXPECT_EQ("}", fmt::format("}}"));
+  EXPECT_EQ("before }", fmt::format("before }}"));
+  EXPECT_EQ("} after", fmt::format("}} after"));
+  EXPECT_EQ("before } after", fmt::format("before }} after"));
 
-  EXPECT_EQ("{}", format("{{}}"));
-  EXPECT_EQ("{42}", format("{{{0}}}", 42));
+  EXPECT_EQ("{}", fmt::format("{{}}"));
+  EXPECT_EQ("{42}", fmt::format("{{{0}}}", 42));
 }
 
-TEST(FormatterTest, UnmatchedBraces) {
-  EXPECT_THROW_MSG(format("{"), format_error, "invalid format string");
-  EXPECT_THROW_MSG(format("}"), format_error, "unmatched '}' in format string");
-  EXPECT_THROW_MSG(format("{0{}"), format_error, "invalid format string");
+TEST(format_test, unmatched_braces) {
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{")), format_error,
+                   "invalid format string");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("}")), format_error,
+                   "unmatched '}' in format string");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0{}")), format_error,
+                   "invalid format string");
 }
 
-TEST(FormatterTest, NoArgs) { EXPECT_EQ("test", format("test")); }
+TEST(format_test, no_args) { EXPECT_EQ("test", fmt::format("test")); }
 
-TEST(FormatterTest, ArgsInDifferentPositions) {
-  EXPECT_EQ("42", format("{0}", 42));
-  EXPECT_EQ("before 42", format("before {0}", 42));
-  EXPECT_EQ("42 after", format("{0} after", 42));
-  EXPECT_EQ("before 42 after", format("before {0} after", 42));
-  EXPECT_EQ("answer = 42", format("{0} = {1}", "answer", 42));
-  EXPECT_EQ("42 is the answer", format("{1} is the {0}", "answer", 42));
-  EXPECT_EQ("abracadabra", format("{0}{1}{0}", "abra", "cad"));
+TEST(format_test, args_in_different_positions) {
+  EXPECT_EQ("42", fmt::format("{0}", 42));
+  EXPECT_EQ("before 42", fmt::format("before {0}", 42));
+  EXPECT_EQ("42 after", fmt::format("{0} after", 42));
+  EXPECT_EQ("before 42 after", fmt::format("before {0} after", 42));
+  EXPECT_EQ("answer = 42", fmt::format("{0} = {1}", "answer", 42));
+  EXPECT_EQ("42 is the answer", fmt::format("{1} is the {0}", "answer", 42));
+  EXPECT_EQ("abracadabra", fmt::format("{0}{1}{0}", "abra", "cad"));
 }
 
-TEST(FormatterTest, ArgErrors) {
-  EXPECT_THROW_MSG(format("{"), format_error, "invalid format string");
-  EXPECT_THROW_MSG(format("{?}"), format_error, "invalid format string");
-  EXPECT_THROW_MSG(format("{0"), format_error, "invalid format string");
-  EXPECT_THROW_MSG(format("{0}"), format_error, "argument not found");
-  EXPECT_THROW_MSG(format("{00}", 42), format_error, "invalid format string");
+TEST(format_test, arg_errors) {
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{")), format_error,
+                   "invalid format string");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{?}")), format_error,
+                   "invalid format string");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0")), format_error,
+                   "invalid format string");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0}")), format_error,
+                   "argument not found");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{00}"), 42), format_error,
+                   "invalid format string");
 
-  char format_str[BUFFER_SIZE];
+  char format_str[buffer_size];
   safe_sprintf(format_str, "{%u", INT_MAX);
-  EXPECT_THROW_MSG(format(format_str), format_error, "invalid format string");
+  EXPECT_THROW_MSG((void)fmt::format(runtime(format_str)), format_error,
+                   "invalid format string");
   safe_sprintf(format_str, "{%u}", INT_MAX);
-  EXPECT_THROW_MSG(format(format_str), format_error, "argument not found");
+  EXPECT_THROW_MSG((void)fmt::format(runtime(format_str)), format_error,
+                   "argument not found");
 
   safe_sprintf(format_str, "{%u", INT_MAX + 1u);
-  EXPECT_THROW_MSG(format(format_str), format_error, "number is too big");
+  EXPECT_THROW_MSG((void)fmt::format(runtime(format_str)), format_error,
+                   "invalid format string");
   safe_sprintf(format_str, "{%u}", INT_MAX + 1u);
-  EXPECT_THROW_MSG(format(format_str), format_error, "number is too big");
+  EXPECT_THROW_MSG((void)fmt::format(runtime(format_str)), format_error,
+                   "argument not found");
 }
 
-template <int N> struct TestFormat {
-  template <typename... Args>
-  static std::string format(fmt::string_view format_str, const Args&... args) {
-    return TestFormat<N - 1>::format(format_str, N - 1, args...);
+template <int N> struct test_format {
+  template <typename... T>
+  static std::string format(fmt::string_view fmt, const T&... args) {
+    return test_format<N - 1>::format(fmt, N - 1, args...);
   }
 };
 
-template <> struct TestFormat<0> {
-  template <typename... Args>
-  static std::string format(fmt::string_view format_str, const Args&... args) {
-    return fmt::format(format_str, args...);
+template <> struct test_format<0> {
+  template <typename... T>
+  static std::string format(fmt::string_view fmt, const T&... args) {
+    return fmt::format(runtime(fmt), args...);
   }
 };
 
-TEST(FormatterTest, ManyArgs) {
-  EXPECT_EQ("19", TestFormat<20>::format("{19}"));
-  EXPECT_THROW_MSG(TestFormat<20>::format("{20}"), format_error,
+TEST(format_test, many_args) {
+  EXPECT_EQ("19", test_format<20>::format("{19}"));
+  EXPECT_THROW_MSG(test_format<20>::format("{20}"), format_error,
                    "argument not found");
-  EXPECT_THROW_MSG(TestFormat<21>::format("{21}"), format_error,
+  EXPECT_THROW_MSG(test_format<21>::format("{21}"), format_error,
                    "argument not found");
-  enum { max_packed_args = fmt::detail::max_packed_args };
+  using fmt::detail::max_packed_args;
   std::string format_str = fmt::format("{{{}}}", max_packed_args + 1);
-  EXPECT_THROW_MSG(TestFormat<max_packed_args>::format(format_str),
+  EXPECT_THROW_MSG(test_format<max_packed_args>::format(format_str),
                    format_error, "argument not found");
 }
 
-TEST(FormatterTest, NamedArg) {
-  EXPECT_EQ("1/a/A", format("{_1}/{a_}/{A_}", fmt::arg("a_", 'a'),
-                            fmt::arg("A_", "A"), fmt::arg("_1", 1)));
-  EXPECT_EQ(" -42", format("{0:{width}}", -42, fmt::arg("width", 4)));
-  EXPECT_EQ("st", format("{0:.{precision}}", "str", fmt::arg("precision", 2)));
-  EXPECT_EQ("1 2", format("{} {two}", 1, fmt::arg("two", 2)));
-  EXPECT_EQ("42", format("{c}", fmt::arg("a", 0), fmt::arg("b", 0),
-                         fmt::arg("c", 42), fmt::arg("d", 0), fmt::arg("e", 0),
-                         fmt::arg("f", 0), fmt::arg("g", 0), fmt::arg("h", 0),
-                         fmt::arg("i", 0), fmt::arg("j", 0), fmt::arg("k", 0),
-                         fmt::arg("l", 0), fmt::arg("m", 0), fmt::arg("n", 0),
-                         fmt::arg("o", 0), fmt::arg("p", 0)));
-  EXPECT_THROW_MSG(format("{a}"), format_error, "argument not found");
-  EXPECT_THROW_MSG(format("{a}", 42), format_error, "argument not found");
-}
-
-TEST(FormatterTest, AutoArgIndex) {
-  EXPECT_EQ("abc", format("{}{}{}", 'a', 'b', 'c'));
-  EXPECT_THROW_MSG(format("{0}{}", 'a', 'b'), format_error,
+TEST(format_test, named_arg) {
+  EXPECT_EQ("1/a/A", fmt::format("{_1}/{a_}/{A_}", fmt::arg("a_", 'a'),
+                                 fmt::arg("A_", "A"), fmt::arg("_1", 1)));
+  EXPECT_EQ(" -42", fmt::format("{0:{width}}", -42, fmt::arg("width", 4)));
+  EXPECT_EQ("st",
+            fmt::format("{0:.{precision}}", "str", fmt::arg("precision", 2)));
+  EXPECT_EQ("1 2", fmt::format("{} {two}", 1, fmt::arg("two", 2)));
+  EXPECT_EQ("42",
+            fmt::format("{c}", fmt::arg("a", 0), fmt::arg("b", 0),
+                        fmt::arg("c", 42), fmt::arg("d", 0), fmt::arg("e", 0),
+                        fmt::arg("f", 0), fmt::arg("g", 0), fmt::arg("h", 0),
+                        fmt::arg("i", 0), fmt::arg("j", 0), fmt::arg("k", 0),
+                        fmt::arg("l", 0), fmt::arg("m", 0), fmt::arg("n", 0),
+                        fmt::arg("o", 0), fmt::arg("p", 0)));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{a}")), format_error,
+                   "argument not found");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{a}"), 42), format_error,
+                   "argument not found");
+}
+
+TEST(format_test, auto_arg_index) {
+  EXPECT_EQ("abc", fmt::format("{}{}{}", 'a', 'b', 'c'));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0}{}"), 'a', 'b'), format_error,
                    "cannot switch from manual to automatic argument indexing");
-  EXPECT_THROW_MSG(format("{}{0}", 'a', 'b'), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{}{0}"), 'a', 'b'), format_error,
                    "cannot switch from automatic to manual argument indexing");
-  EXPECT_EQ("1.2", format("{:.{}}", 1.2345, 2));
-  EXPECT_THROW_MSG(format("{0}:.{}", 1.2345, 2), format_error,
+  EXPECT_EQ("1.2", fmt::format("{:.{}}", 1.2345, 2));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0}:.{}"), 1.2345, 2),
+                   format_error,
                    "cannot switch from manual to automatic argument indexing");
-  EXPECT_THROW_MSG(format("{:.{0}}", 1.2345, 2), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:.{0}}"), 1.2345, 2),
+                   format_error,
                    "cannot switch from automatic to manual argument indexing");
-  EXPECT_THROW_MSG(format("{}"), format_error, "argument not found");
-}
-
-TEST(FormatterTest, EmptySpecs) { EXPECT_EQ("42", format("{0:}", 42)); }
-
-TEST(FormatterTest, LeftAlign) {
-  EXPECT_EQ("42  ", format("{0:<4}", 42));
-  EXPECT_EQ("42  ", format("{0:<4o}", 042));
-  EXPECT_EQ("42  ", format("{0:<4x}", 0x42));
-  EXPECT_EQ("-42  ", format("{0:<5}", -42));
-  EXPECT_EQ("42   ", format("{0:<5}", 42u));
-  EXPECT_EQ("-42  ", format("{0:<5}", -42l));
-  EXPECT_EQ("42   ", format("{0:<5}", 42ul));
-  EXPECT_EQ("-42  ", format("{0:<5}", -42ll));
-  EXPECT_EQ("42   ", format("{0:<5}", 42ull));
-  EXPECT_EQ("-42.0  ", format("{0:<7}", -42.0));
-  EXPECT_EQ("-42.0  ", format("{0:<7}", -42.0l));
-  EXPECT_EQ("c    ", format("{0:<5}", 'c'));
-  EXPECT_EQ("abc  ", format("{0:<5}", "abc"));
-  EXPECT_EQ("0xface  ", format("{0:<8}", reinterpret_cast<void*>(0xface)));
-}
-
-TEST(FormatterTest, RightAlign) {
-  EXPECT_EQ("  42", format("{0:>4}", 42));
-  EXPECT_EQ("  42", format("{0:>4o}", 042));
-  EXPECT_EQ("  42", format("{0:>4x}", 0x42));
-  EXPECT_EQ("  -42", format("{0:>5}", -42));
-  EXPECT_EQ("   42", format("{0:>5}", 42u));
-  EXPECT_EQ("  -42", format("{0:>5}", -42l));
-  EXPECT_EQ("   42", format("{0:>5}", 42ul));
-  EXPECT_EQ("  -42", format("{0:>5}", -42ll));
-  EXPECT_EQ("   42", format("{0:>5}", 42ull));
-  EXPECT_EQ("  -42.0", format("{0:>7}", -42.0));
-  EXPECT_EQ("  -42.0", format("{0:>7}", -42.0l));
-  EXPECT_EQ("    c", format("{0:>5}", 'c'));
-  EXPECT_EQ("  abc", format("{0:>5}", "abc"));
-  EXPECT_EQ("  0xface", format("{0:>8}", reinterpret_cast<void*>(0xface)));
-}
-
-#if FMT_DEPRECATED_NUMERIC_ALIGN
-TEST(FormatterTest, NumericAlign) { EXPECT_EQ("0042", format("{0:=4}", 42)); }
-#endif
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{}")), format_error,
+                   "argument not found");
+}
 
-TEST(FormatterTest, CenterAlign) {
-  EXPECT_EQ(" 42  ", format("{0:^5}", 42));
-  EXPECT_EQ(" 42  ", format("{0:^5o}", 042));
-  EXPECT_EQ(" 42  ", format("{0:^5x}", 0x42));
-  EXPECT_EQ(" -42 ", format("{0:^5}", -42));
-  EXPECT_EQ(" 42  ", format("{0:^5}", 42u));
-  EXPECT_EQ(" -42 ", format("{0:^5}", -42l));
-  EXPECT_EQ(" 42  ", format("{0:^5}", 42ul));
-  EXPECT_EQ(" -42 ", format("{0:^5}", -42ll));
-  EXPECT_EQ(" 42  ", format("{0:^5}", 42ull));
-  EXPECT_EQ(" -42.0 ", format("{0:^7}", -42.0));
-  EXPECT_EQ(" -42.0 ", format("{0:^7}", -42.0l));
-  EXPECT_EQ("  c  ", format("{0:^5}", 'c'));
-  EXPECT_EQ(" abc  ", format("{0:^6}", "abc"));
-  EXPECT_EQ(" 0xface ", format("{0:^8}", reinterpret_cast<void*>(0xface)));
-}
-
-TEST(FormatterTest, Fill) {
-  EXPECT_THROW_MSG(format("{0:{<5}", 'c'), format_error,
+TEST(format_test, empty_specs) { EXPECT_EQ("42", fmt::format("{0:}", 42)); }
+
+TEST(format_test, left_align) {
+  EXPECT_EQ("42  ", fmt::format("{0:<4}", 42));
+  EXPECT_EQ("42  ", fmt::format("{0:<4o}", 042));
+  EXPECT_EQ("42  ", fmt::format("{0:<4x}", 0x42));
+  EXPECT_EQ("-42  ", fmt::format("{0:<5}", -42));
+  EXPECT_EQ("42   ", fmt::format("{0:<5}", 42u));
+  EXPECT_EQ("-42  ", fmt::format("{0:<5}", -42l));
+  EXPECT_EQ("42   ", fmt::format("{0:<5}", 42ul));
+  EXPECT_EQ("-42  ", fmt::format("{0:<5}", -42ll));
+  EXPECT_EQ("42   ", fmt::format("{0:<5}", 42ull));
+  EXPECT_EQ("-42  ", fmt::format("{0:<5}", -42.0));
+  EXPECT_EQ("-42  ", fmt::format("{0:<5}", -42.0l));
+  EXPECT_EQ("c    ", fmt::format("{0:<5}", 'c'));
+  EXPECT_EQ("abc  ", fmt::format("{0:<5}", "abc"));
+  EXPECT_EQ("0xface  ", fmt::format("{0:<8}", reinterpret_cast<void*>(0xface)));
+}
+
+TEST(format_test, right_align) {
+  EXPECT_EQ("  42", fmt::format("{0:>4}", 42));
+  EXPECT_EQ("  42", fmt::format("{0:>4o}", 042));
+  EXPECT_EQ("  42", fmt::format("{0:>4x}", 0x42));
+  EXPECT_EQ("  -42", fmt::format("{0:>5}", -42));
+  EXPECT_EQ("   42", fmt::format("{0:>5}", 42u));
+  EXPECT_EQ("  -42", fmt::format("{0:>5}", -42l));
+  EXPECT_EQ("   42", fmt::format("{0:>5}", 42ul));
+  EXPECT_EQ("  -42", fmt::format("{0:>5}", -42ll));
+  EXPECT_EQ("   42", fmt::format("{0:>5}", 42ull));
+  EXPECT_EQ("  -42", fmt::format("{0:>5}", -42.0));
+  EXPECT_EQ("  -42", fmt::format("{0:>5}", -42.0l));
+  EXPECT_EQ("    c", fmt::format("{0:>5}", 'c'));
+  EXPECT_EQ("  abc", fmt::format("{0:>5}", "abc"));
+  EXPECT_EQ("  0xface", fmt::format("{0:>8}", reinterpret_cast<void*>(0xface)));
+}
+
+TEST(format_test, center_align) {
+  EXPECT_EQ(" 42  ", fmt::format("{0:^5}", 42));
+  EXPECT_EQ(" 42  ", fmt::format("{0:^5o}", 042));
+  EXPECT_EQ(" 42  ", fmt::format("{0:^5x}", 0x42));
+  EXPECT_EQ(" -42 ", fmt::format("{0:^5}", -42));
+  EXPECT_EQ(" 42  ", fmt::format("{0:^5}", 42u));
+  EXPECT_EQ(" -42 ", fmt::format("{0:^5}", -42l));
+  EXPECT_EQ(" 42  ", fmt::format("{0:^5}", 42ul));
+  EXPECT_EQ(" -42 ", fmt::format("{0:^5}", -42ll));
+  EXPECT_EQ(" 42  ", fmt::format("{0:^5}", 42ull));
+  EXPECT_EQ(" -42 ", fmt::format("{0:^5}", -42.0));
+  EXPECT_EQ(" -42 ", fmt::format("{0:^5}", -42.0l));
+  EXPECT_EQ("  c  ", fmt::format("{0:^5}", 'c'));
+  EXPECT_EQ(" abc  ", fmt::format("{0:^6}", "abc"));
+  EXPECT_EQ(" 0xface ", fmt::format("{0:^8}", reinterpret_cast<void*>(0xface)));
+}
+
+TEST(format_test, fill) {
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:{<5}"), 'c'), format_error,
                    "invalid fill character '{'");
-  EXPECT_THROW_MSG(format("{0:{<5}}", 'c'), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:{<5}}"), 'c'), format_error,
                    "invalid fill character '{'");
-  EXPECT_EQ("**42", format("{0:*>4}", 42));
-  EXPECT_EQ("**-42", format("{0:*>5}", -42));
-  EXPECT_EQ("***42", format("{0:*>5}", 42u));
-  EXPECT_EQ("**-42", format("{0:*>5}", -42l));
-  EXPECT_EQ("***42", format("{0:*>5}", 42ul));
-  EXPECT_EQ("**-42", format("{0:*>5}", -42ll));
-  EXPECT_EQ("***42", format("{0:*>5}", 42ull));
-  EXPECT_EQ("**-42.0", format("{0:*>7}", -42.0));
-  EXPECT_EQ("**-42.0", format("{0:*>7}", -42.0l));
-  EXPECT_EQ("c****", format("{0:*<5}", 'c'));
-  EXPECT_EQ("abc**", format("{0:*<5}", "abc"));
-  EXPECT_EQ("**0xface", format("{0:*>8}", reinterpret_cast<void*>(0xface)));
-  EXPECT_EQ("foo=", format("{:}=", "foo"));
-  EXPECT_EQ(std::string("\0\0\0*", 4), format(string_view("{:\0>4}", 6), '*'));
-  EXPECT_EQ("жж42", format("{0:ж>4}", 42));
-  EXPECT_THROW_MSG(format("{:\x80\x80\x80\x80\x80>}", 0), format_error,
-                   "invalid fill");
-}
-
-TEST(FormatterTest, PlusSign) {
-  EXPECT_EQ("+42", format("{0:+}", 42));
-  EXPECT_EQ("-42", format("{0:+}", -42));
-  EXPECT_EQ("+42", format("{0:+}", 42));
-  EXPECT_THROW_MSG(format("{0:+}", 42u), format_error,
+  EXPECT_EQ("**42", fmt::format("{0:*>4}", 42));
+  EXPECT_EQ("**-42", fmt::format("{0:*>5}", -42));
+  EXPECT_EQ("***42", fmt::format("{0:*>5}", 42u));
+  EXPECT_EQ("**-42", fmt::format("{0:*>5}", -42l));
+  EXPECT_EQ("***42", fmt::format("{0:*>5}", 42ul));
+  EXPECT_EQ("**-42", fmt::format("{0:*>5}", -42ll));
+  EXPECT_EQ("***42", fmt::format("{0:*>5}", 42ull));
+  EXPECT_EQ("**-42", fmt::format("{0:*>5}", -42.0));
+  EXPECT_EQ("**-42", fmt::format("{0:*>5}", -42.0l));
+  EXPECT_EQ("c****", fmt::format("{0:*<5}", 'c'));
+  EXPECT_EQ("abc**", fmt::format("{0:*<5}", "abc"));
+  EXPECT_EQ("**0xface",
+            fmt::format("{0:*>8}", reinterpret_cast<void*>(0xface)));
+  EXPECT_EQ("foo=", fmt::format("{:}=", "foo"));
+  EXPECT_EQ(std::string("\0\0\0*", 4),
+            fmt::format(string_view("{:\0>4}", 6), '*'));
+  EXPECT_EQ("жж42", fmt::format("{0:ж>4}", 42));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:\x80\x80\x80\x80\x80>}"), 0),
+                   format_error, "invalid type specifier");
+}
+
+TEST(format_test, plus_sign) {
+  EXPECT_EQ("+42", fmt::format("{0:+}", 42));
+  EXPECT_EQ("-42", fmt::format("{0:+}", -42));
+  EXPECT_EQ("+42", fmt::format("{0:+}", 42));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:+}"), 42u), format_error,
                    "format specifier requires signed argument");
-  EXPECT_EQ("+42", format("{0:+}", 42l));
-  EXPECT_THROW_MSG(format("{0:+}", 42ul), format_error,
+  EXPECT_EQ("+42", fmt::format("{0:+}", 42l));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:+}"), 42ul), format_error,
                    "format specifier requires signed argument");
-  EXPECT_EQ("+42", format("{0:+}", 42ll));
-  EXPECT_THROW_MSG(format("{0:+}", 42ull), format_error,
+  EXPECT_EQ("+42", fmt::format("{0:+}", 42ll));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:+}"), 42ull), format_error,
                    "format specifier requires signed argument");
-  EXPECT_EQ("+42.0", format("{0:+}", 42.0));
-  EXPECT_EQ("+42.0", format("{0:+}", 42.0l));
-  EXPECT_THROW_MSG(format("{0:+", 'c'), format_error,
+  EXPECT_EQ("+42", fmt::format("{0:+}", 42.0));
+  EXPECT_EQ("+42", fmt::format("{0:+}", 42.0l));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:+"), 'c'), format_error,
                    "missing '}' in format string");
-  EXPECT_THROW_MSG(format("{0:+}", 'c'), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:+}"), 'c'), format_error,
                    "invalid format specifier for char");
-  EXPECT_THROW_MSG(format("{0:+}", "abc"), format_error,
-                   "format specifier requires numeric argument");
-  EXPECT_THROW_MSG(format("{0:+}", reinterpret_cast<void*>(0x42)), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:+}"), "abc"), format_error,
                    "format specifier requires numeric argument");
+  EXPECT_THROW_MSG(
+      (void)fmt::format(runtime("{0:+}"), reinterpret_cast<void*>(0x42)),
+      format_error, "format specifier requires numeric argument");
 }
 
-TEST(FormatterTest, MinusSign) {
-  EXPECT_EQ("42", format("{0:-}", 42));
-  EXPECT_EQ("-42", format("{0:-}", -42));
-  EXPECT_EQ("42", format("{0:-}", 42));
-  EXPECT_THROW_MSG(format("{0:-}", 42u), format_error,
+TEST(format_test, minus_sign) {
+  EXPECT_EQ("42", fmt::format("{0:-}", 42));
+  EXPECT_EQ("-42", fmt::format("{0:-}", -42));
+  EXPECT_EQ("42", fmt::format("{0:-}", 42));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:-}"), 42u), format_error,
                    "format specifier requires signed argument");
-  EXPECT_EQ("42", format("{0:-}", 42l));
-  EXPECT_THROW_MSG(format("{0:-}", 42ul), format_error,
+  EXPECT_EQ("42", fmt::format("{0:-}", 42l));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:-}"), 42ul), format_error,
                    "format specifier requires signed argument");
-  EXPECT_EQ("42", format("{0:-}", 42ll));
-  EXPECT_THROW_MSG(format("{0:-}", 42ull), format_error,
+  EXPECT_EQ("42", fmt::format("{0:-}", 42ll));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:-}"), 42ull), format_error,
                    "format specifier requires signed argument");
-  EXPECT_EQ("42.0", format("{0:-}", 42.0));
-  EXPECT_EQ("42.0", format("{0:-}", 42.0l));
-  EXPECT_THROW_MSG(format("{0:-", 'c'), format_error,
+  EXPECT_EQ("42", fmt::format("{0:-}", 42.0));
+  EXPECT_EQ("42", fmt::format("{0:-}", 42.0l));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:-"), 'c'), format_error,
                    "missing '}' in format string");
-  EXPECT_THROW_MSG(format("{0:-}", 'c'), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:-}"), 'c'), format_error,
                    "invalid format specifier for char");
-  EXPECT_THROW_MSG(format("{0:-}", "abc"), format_error,
-                   "format specifier requires numeric argument");
-  EXPECT_THROW_MSG(format("{0:-}", reinterpret_cast<void*>(0x42)), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:-}"), "abc"), format_error,
                    "format specifier requires numeric argument");
+  EXPECT_THROW_MSG(
+      (void)fmt::format(runtime("{0:-}"), reinterpret_cast<void*>(0x42)),
+      format_error, "format specifier requires numeric argument");
 }
 
-TEST(FormatterTest, SpaceSign) {
-  EXPECT_EQ(" 42", format("{0: }", 42));
-  EXPECT_EQ("-42", format("{0: }", -42));
-  EXPECT_EQ(" 42", format("{0: }", 42));
-  EXPECT_THROW_MSG(format("{0: }", 42u), format_error,
+TEST(format_test, space_sign) {
+  EXPECT_EQ(" 42", fmt::format("{0: }", 42));
+  EXPECT_EQ("-42", fmt::format("{0: }", -42));
+  EXPECT_EQ(" 42", fmt::format("{0: }", 42));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0: }"), 42u), format_error,
                    "format specifier requires signed argument");
-  EXPECT_EQ(" 42", format("{0: }", 42l));
-  EXPECT_THROW_MSG(format("{0: }", 42ul), format_error,
+  EXPECT_EQ(" 42", fmt::format("{0: }", 42l));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0: }"), 42ul), format_error,
                    "format specifier requires signed argument");
-  EXPECT_EQ(" 42", format("{0: }", 42ll));
-  EXPECT_THROW_MSG(format("{0: }", 42ull), format_error,
+  EXPECT_EQ(" 42", fmt::format("{0: }", 42ll));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0: }"), 42ull), format_error,
                    "format specifier requires signed argument");
-  EXPECT_EQ(" 42.0", format("{0: }", 42.0));
-  EXPECT_EQ(" 42.0", format("{0: }", 42.0l));
-  EXPECT_THROW_MSG(format("{0: ", 'c'), format_error,
+  EXPECT_EQ(" 42", fmt::format("{0: }", 42.0));
+  EXPECT_EQ(" 42", fmt::format("{0: }", 42.0l));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0: "), 'c'), format_error,
                    "missing '}' in format string");
-  EXPECT_THROW_MSG(format("{0: }", 'c'), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0: }"), 'c'), format_error,
                    "invalid format specifier for char");
-  EXPECT_THROW_MSG(format("{0: }", "abc"), format_error,
-                   "format specifier requires numeric argument");
-  EXPECT_THROW_MSG(format("{0: }", reinterpret_cast<void*>(0x42)), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0: }"), "abc"), format_error,
                    "format specifier requires numeric argument");
-}
-
-TEST(FormatterTest, HashFlag) {
-  EXPECT_EQ("42", format("{0:#}", 42));
-  EXPECT_EQ("-42", format("{0:#}", -42));
-  EXPECT_EQ("0b101010", format("{0:#b}", 42));
-  EXPECT_EQ("0B101010", format("{0:#B}", 42));
-  EXPECT_EQ("-0b101010", format("{0:#b}", -42));
-  EXPECT_EQ("0x42", format("{0:#x}", 0x42));
-  EXPECT_EQ("0X42", format("{0:#X}", 0x42));
-  EXPECT_EQ("-0x42", format("{0:#x}", -0x42));
-  EXPECT_EQ("0", format("{0:#o}", 0));
-  EXPECT_EQ("042", format("{0:#o}", 042));
-  EXPECT_EQ("-042", format("{0:#o}", -042));
-  EXPECT_EQ("42", format("{0:#}", 42u));
-  EXPECT_EQ("0x42", format("{0:#x}", 0x42u));
-  EXPECT_EQ("042", format("{0:#o}", 042u));
-
-  EXPECT_EQ("-42", format("{0:#}", -42l));
-  EXPECT_EQ("0x42", format("{0:#x}", 0x42l));
-  EXPECT_EQ("-0x42", format("{0:#x}", -0x42l));
-  EXPECT_EQ("042", format("{0:#o}", 042l));
-  EXPECT_EQ("-042", format("{0:#o}", -042l));
-  EXPECT_EQ("42", format("{0:#}", 42ul));
-  EXPECT_EQ("0x42", format("{0:#x}", 0x42ul));
-  EXPECT_EQ("042", format("{0:#o}", 042ul));
-
-  EXPECT_EQ("-42", format("{0:#}", -42ll));
-  EXPECT_EQ("0x42", format("{0:#x}", 0x42ll));
-  EXPECT_EQ("-0x42", format("{0:#x}", -0x42ll));
-  EXPECT_EQ("042", format("{0:#o}", 042ll));
-  EXPECT_EQ("-042", format("{0:#o}", -042ll));
-  EXPECT_EQ("42", format("{0:#}", 42ull));
-  EXPECT_EQ("0x42", format("{0:#x}", 0x42ull));
-  EXPECT_EQ("042", format("{0:#o}", 042ull));
-
-  EXPECT_EQ("-42.0", format("{0:#}", -42.0));
-  EXPECT_EQ("-42.0", format("{0:#}", -42.0l));
-  EXPECT_EQ("4.e+01", format("{:#.0e}", 42.0));
-  EXPECT_EQ("0.", format("{:#.0f}", 0.01));
-  auto s = format("{:#.0f}", 0.5);  // MSVC's printf uses wrong rounding mode.
-  EXPECT_TRUE(s == "0." || s == "1.");
-  EXPECT_THROW_MSG(format("{0:#", 'c'), format_error,
+  EXPECT_THROW_MSG(
+      (void)fmt::format(runtime("{0: }"), reinterpret_cast<void*>(0x42)),
+      format_error, "format specifier requires numeric argument");
+}
+
+TEST(format_test, hash_flag) {
+  EXPECT_EQ("42", fmt::format("{0:#}", 42));
+  EXPECT_EQ("-42", fmt::format("{0:#}", -42));
+  EXPECT_EQ("0b101010", fmt::format("{0:#b}", 42));
+  EXPECT_EQ("0B101010", fmt::format("{0:#B}", 42));
+  EXPECT_EQ("-0b101010", fmt::format("{0:#b}", -42));
+  EXPECT_EQ("0x42", fmt::format("{0:#x}", 0x42));
+  EXPECT_EQ("0X42", fmt::format("{0:#X}", 0x42));
+  EXPECT_EQ("-0x42", fmt::format("{0:#x}", -0x42));
+  EXPECT_EQ("0", fmt::format("{0:#o}", 0));
+  EXPECT_EQ("042", fmt::format("{0:#o}", 042));
+  EXPECT_EQ("-042", fmt::format("{0:#o}", -042));
+  EXPECT_EQ("42", fmt::format("{0:#}", 42u));
+  EXPECT_EQ("0x42", fmt::format("{0:#x}", 0x42u));
+  EXPECT_EQ("042", fmt::format("{0:#o}", 042u));
+
+  EXPECT_EQ("-42", fmt::format("{0:#}", -42l));
+  EXPECT_EQ("0x42", fmt::format("{0:#x}", 0x42l));
+  EXPECT_EQ("-0x42", fmt::format("{0:#x}", -0x42l));
+  EXPECT_EQ("042", fmt::format("{0:#o}", 042l));
+  EXPECT_EQ("-042", fmt::format("{0:#o}", -042l));
+  EXPECT_EQ("42", fmt::format("{0:#}", 42ul));
+  EXPECT_EQ("0x42", fmt::format("{0:#x}", 0x42ul));
+  EXPECT_EQ("042", fmt::format("{0:#o}", 042ul));
+
+  EXPECT_EQ("-42", fmt::format("{0:#}", -42ll));
+  EXPECT_EQ("0x42", fmt::format("{0:#x}", 0x42ll));
+  EXPECT_EQ("-0x42", fmt::format("{0:#x}", -0x42ll));
+  EXPECT_EQ("042", fmt::format("{0:#o}", 042ll));
+  EXPECT_EQ("-042", fmt::format("{0:#o}", -042ll));
+  EXPECT_EQ("42", fmt::format("{0:#}", 42ull));
+  EXPECT_EQ("0x42", fmt::format("{0:#x}", 0x42ull));
+  EXPECT_EQ("042", fmt::format("{0:#o}", 042ull));
+
+  EXPECT_EQ("-42.0", fmt::format("{0:#}", -42.0));
+  EXPECT_EQ("-42.0", fmt::format("{0:#}", -42.0l));
+  EXPECT_EQ("4.e+01", fmt::format("{:#.0e}", 42.0));
+  EXPECT_EQ("0.", fmt::format("{:#.0f}", 0.01));
+  EXPECT_EQ("0.50", fmt::format("{:#.2g}", 0.5));
+  EXPECT_EQ("0.", fmt::format("{:#.0f}", 0.5));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:#"), 'c'), format_error,
                    "missing '}' in format string");
-  EXPECT_THROW_MSG(format("{0:#}", 'c'), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:#}"), 'c'), format_error,
                    "invalid format specifier for char");
-  EXPECT_THROW_MSG(format("{0:#}", "abc"), format_error,
-                   "format specifier requires numeric argument");
-  EXPECT_THROW_MSG(format("{0:#}", reinterpret_cast<void*>(0x42)), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:#}"), "abc"), format_error,
                    "format specifier requires numeric argument");
-}
-
-TEST(FormatterTest, ZeroFlag) {
-  EXPECT_EQ("42", format("{0:0}", 42));
-  EXPECT_EQ("-0042", format("{0:05}", -42));
-  EXPECT_EQ("00042", format("{0:05}", 42u));
-  EXPECT_EQ("-0042", format("{0:05}", -42l));
-  EXPECT_EQ("00042", format("{0:05}", 42ul));
-  EXPECT_EQ("-0042", format("{0:05}", -42ll));
-  EXPECT_EQ("00042", format("{0:05}", 42ull));
-  EXPECT_EQ("-0042.0", format("{0:07}", -42.0));
-  EXPECT_EQ("-0042.0", format("{0:07}", -42.0l));
-  EXPECT_THROW_MSG(format("{0:0", 'c'), format_error,
+  EXPECT_THROW_MSG(
+      (void)fmt::format(runtime("{0:#}"), reinterpret_cast<void*>(0x42)),
+      format_error, "format specifier requires numeric argument");
+}
+
+TEST(format_test, zero_flag) {
+  EXPECT_EQ("42", fmt::format("{0:0}", 42));
+  EXPECT_EQ("-0042", fmt::format("{0:05}", -42));
+  EXPECT_EQ("00042", fmt::format("{0:05}", 42u));
+  EXPECT_EQ("-0042", fmt::format("{0:05}", -42l));
+  EXPECT_EQ("00042", fmt::format("{0:05}", 42ul));
+  EXPECT_EQ("-0042", fmt::format("{0:05}", -42ll));
+  EXPECT_EQ("00042", fmt::format("{0:05}", 42ull));
+  EXPECT_EQ("-000042", fmt::format("{0:07}", -42.0));
+  EXPECT_EQ("-000042", fmt::format("{0:07}", -42.0l));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:0"), 'c'), format_error,
                    "missing '}' in format string");
-  EXPECT_THROW_MSG(format("{0:05}", 'c'), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:05}"), 'c'), format_error,
                    "invalid format specifier for char");
-  EXPECT_THROW_MSG(format("{0:05}", "abc"), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:05}"), "abc"), format_error,
                    "format specifier requires numeric argument");
-  EXPECT_THROW_MSG(format("{0:05}", reinterpret_cast<void*>(0x42)),
-                   format_error, "format specifier requires numeric argument");
+  EXPECT_THROW_MSG(
+      (void)fmt::format(runtime("{0:05}"), reinterpret_cast<void*>(0x42)),
+      format_error, "format specifier requires numeric argument");
 }
 
-TEST(FormatterTest, Width) {
-  char format_str[BUFFER_SIZE];
+TEST(format_test, width) {
+  char format_str[buffer_size];
   safe_sprintf(format_str, "{0:%u", UINT_MAX);
   increment(format_str + 3);
-  EXPECT_THROW_MSG(format(format_str, 0), format_error, "number is too big");
+  EXPECT_THROW_MSG((void)fmt::format(runtime(format_str), 0), format_error,
+                   "number is too big");
   size_t size = std::strlen(format_str);
   format_str[size] = '}';
   format_str[size + 1] = 0;
-  EXPECT_THROW_MSG(format(format_str, 0), format_error, "number is too big");
+  EXPECT_THROW_MSG((void)fmt::format(runtime(format_str), 0), format_error,
+                   "number is too big");
 
   safe_sprintf(format_str, "{0:%u", INT_MAX + 1u);
-  EXPECT_THROW_MSG(format(format_str, 0), format_error, "number is too big");
+  EXPECT_THROW_MSG((void)fmt::format(runtime(format_str), 0), format_error,
+                   "number is too big");
   safe_sprintf(format_str, "{0:%u}", INT_MAX + 1u);
-  EXPECT_THROW_MSG(format(format_str, 0), format_error, "number is too big");
-  EXPECT_EQ(" -42", format("{0:4}", -42));
-  EXPECT_EQ("   42", format("{0:5}", 42u));
-  EXPECT_EQ("   -42", format("{0:6}", -42l));
-  EXPECT_EQ("     42", format("{0:7}", 42ul));
-  EXPECT_EQ("   -42", format("{0:6}", -42ll));
-  EXPECT_EQ("     42", format("{0:7}", 42ull));
-  EXPECT_EQ("   -1.23", format("{0:8}", -1.23));
-  EXPECT_EQ("    -1.23", format("{0:9}", -1.23l));
-  EXPECT_EQ("    0xcafe", format("{0:10}", reinterpret_cast<void*>(0xcafe)));
-  EXPECT_EQ("x          ", format("{0:11}", 'x'));
-  EXPECT_EQ("str         ", format("{0:12}", "str"));
-  EXPECT_EQ(fmt::format("{:*^5}", "🤡"), "**🤡**");
-}
-
-template <typename T> inline T const_check(T value) { return value; }
-
-TEST(FormatterTest, RuntimeWidth) {
-  char format_str[BUFFER_SIZE];
+  EXPECT_THROW_MSG((void)fmt::format(runtime(format_str), 0), format_error,
+                   "number is too big");
+  EXPECT_EQ(" -42", fmt::format("{0:4}", -42));
+  EXPECT_EQ("   42", fmt::format("{0:5}", 42u));
+  EXPECT_EQ("   -42", fmt::format("{0:6}", -42l));
+  EXPECT_EQ("     42", fmt::format("{0:7}", 42ul));
+  EXPECT_EQ("   -42", fmt::format("{0:6}", -42ll));
+  EXPECT_EQ("     42", fmt::format("{0:7}", 42ull));
+  EXPECT_EQ("   -1.23", fmt::format("{0:8}", -1.23));
+  EXPECT_EQ("    -1.23", fmt::format("{0:9}", -1.23l));
+  EXPECT_EQ("    0xcafe",
+            fmt::format("{0:10}", reinterpret_cast<void*>(0xcafe)));
+  EXPECT_EQ("x          ", fmt::format("{0:11}", 'x'));
+  EXPECT_EQ("str         ", fmt::format("{0:12}", "str"));
+  EXPECT_EQ(fmt::format("{:*^6}", "🤡"), "**🤡**");
+  EXPECT_EQ(fmt::format("{:*^8}", "你好"), "**你好**");
+  EXPECT_EQ(fmt::format("{:#6}", 42.0), "  42.0");
+  EXPECT_EQ(fmt::format("{:6c}", static_cast<int>('x')), "x     ");
+  EXPECT_EQ(fmt::format("{:>06.0f}", 0.00884311), "000000");
+}
+
+TEST(format_test, runtime_width) {
+  char format_str[buffer_size];
   safe_sprintf(format_str, "{0:{%u", UINT_MAX);
   increment(format_str + 4);
-  EXPECT_THROW_MSG(format(format_str, 0), format_error, "number is too big");
+  EXPECT_THROW_MSG((void)fmt::format(runtime(format_str), 0), format_error,
+                   "invalid format string");
   size_t size = std::strlen(format_str);
   format_str[size] = '}';
   format_str[size + 1] = 0;
-  EXPECT_THROW_MSG(format(format_str, 0), format_error, "number is too big");
+  EXPECT_THROW_MSG((void)fmt::format(runtime(format_str), 0), format_error,
+                   "argument not found");
   format_str[size + 1] = '}';
   format_str[size + 2] = 0;
-  EXPECT_THROW_MSG(format(format_str, 0), format_error, "number is too big");
+  EXPECT_THROW_MSG((void)fmt::format(runtime(format_str), 0), format_error,
+                   "argument not found");
 
-  EXPECT_THROW_MSG(format("{0:{", 0), format_error, "invalid format string");
-  EXPECT_THROW_MSG(format("{0:{}", 0), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:{"), 0), format_error,
+                   "invalid format string");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:{}"), 0), format_error,
                    "cannot switch from manual to automatic argument indexing");
-  EXPECT_THROW_MSG(format("{0:{?}}", 0), format_error, "invalid format string");
-  EXPECT_THROW_MSG(format("{0:{1}}", 0), format_error, "argument not found");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:{?}}"), 0), format_error,
+                   "invalid format string");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:{1}}"), 0), format_error,
+                   "argument not found");
 
-  EXPECT_THROW_MSG(format("{0:{0:}}", 0), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:{0:}}"), 0), format_error,
                    "invalid format string");
 
-  EXPECT_THROW_MSG(format("{0:{1}}", 0, -1), format_error, "negative width");
-  EXPECT_THROW_MSG(format("{0:{1}}", 0, (INT_MAX + 1u)), format_error,
-                   "number is too big");
-  EXPECT_THROW_MSG(format("{0:{1}}", 0, -1l), format_error, "negative width");
-  if (const_check(sizeof(long) > sizeof(int))) {
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:{1}}"), 0, -1), format_error,
+                   "negative width");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:{1}}"), 0, (INT_MAX + 1u)),
+                   format_error, "number is too big");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:{1}}"), 0, -1l), format_error,
+                   "negative width");
+  if (fmt::detail::const_check(sizeof(long) > sizeof(int))) {
     long value = INT_MAX;
-    EXPECT_THROW_MSG(format("{0:{1}}", 0, (value + 1)), format_error,
-                     "number is too big");
+    EXPECT_THROW_MSG((void)fmt::format(runtime("{0:{1}}"), 0, (value + 1)),
+                     format_error, "number is too big");
   }
-  EXPECT_THROW_MSG(format("{0:{1}}", 0, (INT_MAX + 1ul)), format_error,
-                   "number is too big");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:{1}}"), 0, (INT_MAX + 1ul)),
+                   format_error, "number is too big");
 
-  EXPECT_THROW_MSG(format("{0:{1}}", 0, '0'), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:{1}}"), 0, '0'), format_error,
                    "width is not integer");
-  EXPECT_THROW_MSG(format("{0:{1}}", 0, 0.0), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:{1}}"), 0, 0.0), format_error,
                    "width is not integer");
 
-  EXPECT_EQ(" -42", format("{0:{1}}", -42, 4));
-  EXPECT_EQ("   42", format("{0:{1}}", 42u, 5));
-  EXPECT_EQ("   -42", format("{0:{1}}", -42l, 6));
-  EXPECT_EQ("     42", format("{0:{1}}", 42ul, 7));
-  EXPECT_EQ("   -42", format("{0:{1}}", -42ll, 6));
-  EXPECT_EQ("     42", format("{0:{1}}", 42ull, 7));
-  EXPECT_EQ("   -1.23", format("{0:{1}}", -1.23, 8));
-  EXPECT_EQ("    -1.23", format("{0:{1}}", -1.23l, 9));
+  EXPECT_EQ(" -42", fmt::format("{0:{1}}", -42, 4));
+  EXPECT_EQ("   42", fmt::format("{0:{1}}", 42u, 5));
+  EXPECT_EQ("   -42", fmt::format("{0:{1}}", -42l, 6));
+  EXPECT_EQ("     42", fmt::format("{0:{1}}", 42ul, 7));
+  EXPECT_EQ("   -42", fmt::format("{0:{1}}", -42ll, 6));
+  EXPECT_EQ("     42", fmt::format("{0:{1}}", 42ull, 7));
+  EXPECT_EQ("   -1.23", fmt::format("{0:{1}}", -1.23, 8));
+  EXPECT_EQ("    -1.23", fmt::format("{0:{1}}", -1.23l, 9));
   EXPECT_EQ("    0xcafe",
-            format("{0:{1}}", reinterpret_cast<void*>(0xcafe), 10));
-  EXPECT_EQ("x          ", format("{0:{1}}", 'x', 11));
-  EXPECT_EQ("str         ", format("{0:{1}}", "str", 12));
+            fmt::format("{0:{1}}", reinterpret_cast<void*>(0xcafe), 10));
+  EXPECT_EQ("x          ", fmt::format("{0:{1}}", 'x', 11));
+  EXPECT_EQ("str         ", fmt::format("{0:{1}}", "str", 12));
 }
 
-TEST(FormatterTest, Precision) {
-  char format_str[BUFFER_SIZE];
+TEST(format_test, precision) {
+  char format_str[buffer_size];
   safe_sprintf(format_str, "{0:.%u", UINT_MAX);
   increment(format_str + 4);
-  EXPECT_THROW_MSG(format(format_str, 0), format_error, "number is too big");
+  EXPECT_THROW_MSG((void)fmt::format(runtime(format_str), 0), format_error,
+                   "number is too big");
   size_t size = std::strlen(format_str);
   format_str[size] = '}';
   format_str[size + 1] = 0;
-  EXPECT_THROW_MSG(format(format_str, 0), format_error, "number is too big");
+  EXPECT_THROW_MSG((void)fmt::format(runtime(format_str), 0), format_error,
+                   "number is too big");
 
   safe_sprintf(format_str, "{0:.%u", INT_MAX + 1u);
-  EXPECT_THROW_MSG(format(format_str, 0), format_error, "number is too big");
+  EXPECT_THROW_MSG((void)fmt::format(runtime(format_str), 0), format_error,
+                   "number is too big");
   safe_sprintf(format_str, "{0:.%u}", INT_MAX + 1u);
-  EXPECT_THROW_MSG(format(format_str, 0), format_error, "number is too big");
+  EXPECT_THROW_MSG((void)fmt::format(runtime(format_str), 0), format_error,
+                   "number is too big");
 
-  EXPECT_THROW_MSG(format("{0:.", 0), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:."), 0), format_error,
                    "missing precision specifier");
-  EXPECT_THROW_MSG(format("{0:.}", 0), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:.}"), 0), format_error,
                    "missing precision specifier");
 
-  EXPECT_THROW_MSG(format("{0:.2", 0), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:.2"), 0), format_error,
                    "precision not allowed for this argument type");
-  EXPECT_THROW_MSG(format("{0:.2}", 42), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:.2}"), 42), format_error,
                    "precision not allowed for this argument type");
-  EXPECT_THROW_MSG(format("{0:.2f}", 42), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:.2f}"), 42), format_error,
                    "precision not allowed for this argument type");
-  EXPECT_THROW_MSG(format("{0:.2}", 42u), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:.2}"), 42u), format_error,
                    "precision not allowed for this argument type");
-  EXPECT_THROW_MSG(format("{0:.2f}", 42u), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:.2f}"), 42u), format_error,
                    "precision not allowed for this argument type");
-  EXPECT_THROW_MSG(format("{0:.2}", 42l), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:.2}"), 42l), format_error,
                    "precision not allowed for this argument type");
-  EXPECT_THROW_MSG(format("{0:.2f}", 42l), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:.2f}"), 42l), format_error,
                    "precision not allowed for this argument type");
-  EXPECT_THROW_MSG(format("{0:.2}", 42ul), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:.2}"), 42ul), format_error,
                    "precision not allowed for this argument type");
-  EXPECT_THROW_MSG(format("{0:.2f}", 42ul), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:.2f}"), 42ul), format_error,
                    "precision not allowed for this argument type");
-  EXPECT_THROW_MSG(format("{0:.2}", 42ll), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:.2}"), 42ll), format_error,
                    "precision not allowed for this argument type");
-  EXPECT_THROW_MSG(format("{0:.2f}", 42ll), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:.2f}"), 42ll), format_error,
                    "precision not allowed for this argument type");
-  EXPECT_THROW_MSG(format("{0:.2}", 42ull), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:.2}"), 42ull), format_error,
                    "precision not allowed for this argument type");
-  EXPECT_THROW_MSG(format("{0:.2f}", 42ull), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:.2f}"), 42ull), format_error,
                    "precision not allowed for this argument type");
-  EXPECT_THROW_MSG(format("{0:3.0}", 'x'), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:3.0}"), 'x'), format_error,
                    "precision not allowed for this argument type");
-  EXPECT_EQ("1.2", format("{0:.2}", 1.2345));
-  EXPECT_EQ("1.2", format("{0:.2}", 1.2345l));
-  EXPECT_EQ("1.2e+56", format("{:.2}", 1.234e56));
-  EXPECT_EQ("1e+00", format("{:.0e}", 1.0L));
-  EXPECT_EQ("  0.0e+00", format("{:9.1e}", 0.0));
+  EXPECT_EQ("1.2", fmt::format("{0:.2}", 1.2345));
+  EXPECT_EQ("1.2", fmt::format("{0:.2}", 1.2345l));
+  EXPECT_EQ("1.2e+56", fmt::format("{:.2}", 1.234e56));
+  EXPECT_EQ("1.1", fmt::format("{0:.3}", 1.1));
+  EXPECT_EQ("1e+00", fmt::format("{:.0e}", 1.0L));
+  EXPECT_EQ("  0.0e+00", fmt::format("{:9.1e}", 0.0));
   EXPECT_EQ(
+      fmt::format("{:.494}", 4.9406564584124654E-324),
       "4.9406564584124654417656879286822137236505980261432476442558568250067550"
       "727020875186529983636163599237979656469544571773092665671035593979639877"
       "479601078187812630071319031140452784581716784898210368871863605699873072"
       "305000638740915356498438731247339727316961514003171538539807412623856559"
       "117102665855668676818703956031062493194527159149245532930545654440112748"
       "012970999954193198940908041656332452475714786901472678015935523861155013"
-      "480352649347201937902681071074917033322268447533357208324319361e-324",
-      format("{:.494}", 4.9406564584124654E-324));
+      "480352649347201937902681071074917033322268447533357208324319361e-324");
   EXPECT_EQ(
+      fmt::format("{:.1074f}", 1.1125369292536e-308),
+      "0.0000000000000000000000000000000000000000000000000000000000000000000000"
+      "000000000000000000000000000000000000000000000000000000000000000000000000"
+      "000000000000000000000000000000000000000000000000000000000000000000000000"
+      "000000000000000000000000000000000000000000000000000000000000000000000000"
+      "000000000000000000000111253692925360019747947051741965785554081512200979"
+      "355021686109411883779182127659725163430929750364498219730822952552570601"
+      "152163505899912777129583674906301179059298598412303893909188340988729019"
+      "014361467448914817838555156840459458527907308695109202499990850735085304"
+      "478476991912072201449236975063640913461919914396877093174125167509869762"
+      "482369631100360266123742648159508919592746619553246586039571522788247697"
+      "156360766271842991667238355464496455107749716934387136380536472531224398"
+      "559833794807213172371254492216255558078524900147957309382830827524104234"
+      "530961756787819847850302379672357738807808384667004752163416921762619527"
+      "462847642037420991432005657440259928195996762610375541867198059294212446"
+      "81962777939941034720757232455434770912461317493580281734466552734375");
+
+  std::string outputs[] = {
       "-0X1.41FE3FFE71C9E000000000000000000000000000000000000000000000000000000"
       "000000000000000000000000000000000000000000000000000000000000000000000000"
       "000000000000000000000000000000000000000000000000000000000000000000000000"
